<?php
/* DOSYANIN ALT KISMINDA CONFIG MEVCUT VERİTABANI BAĞLANTISI İÇİN!
DATABASE CONFIG BELOW CLASS */
class Database {
    private $pdo;
    private $stmt;

    public function __construct($host, $dbname, $username, $password) {
        $dsn = "mysql:host=$host;dbname=$dbname;charset=utf8";
        $this->pdo = new PDO($dsn, $username, $password);
        $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
    }

    public function query($sql, $params = []) {
        $this->stmt = $this->pdo->prepare($sql);
        $this->stmt->execute($params);
    }

    public function fetch($sql, $params = []) {
        $this->query($sql, $params);
        return $this->stmt->fetch(PDO::FETCH_ASSOC);
    }

    public function fetchAll($sql, $params = []) {
        $this->query($sql, $params);
        return $this->stmt->fetchAll(PDO::FETCH_ASSOC);
    }

    public function execute($sql, $params = []) {
        $this->query($sql, $params);
        return $this->stmt->rowCount();
    }

    public function insert($table, $data) {
        $fields = implode(", ", array_keys($data));
        $placeholders = ":" . implode(", :", array_keys($data));
        $sql = "INSERT INTO $table ($fields) VALUES ($placeholders)";
        $this->execute($sql, $data);
        return $this->pdo->lastInsertId();
    }

    public function update($table, $data, $where = []) {
        $fields = "";
        foreach ($data as $key => $value) {
            $fields .= "$key = :$key, ";
        }
        $fields = rtrim($fields, ", ");
        if (count($where) > 0) {
        $whereClause = "";
        foreach ($where as $key => $value) {
            $whereClause .= "$key = :$key AND ";
        }
        $whereClause = rtrim($whereClause, " AND ");
        $sql = "UPDATE $table SET $fields WHERE $whereClause";
        } else {
            $sql = "UPDATE $table SET $fields";
        }
        $params = array_merge($data, $where);
        return $this->execute($sql, $params);
    }

    public function delete($table, $where) {
        $whereClause = "";
        foreach ($where as $key => $value) {
            $whereClause .= "$key = :$key AND ";
        }
        $whereClause = rtrim($whereClause, " AND ");
        $sql = "DELETE FROM $table WHERE $whereClause";
        return $this->execute($sql, $where);
    }
}

$db = new Database('localhost', 'jojobets_db52', 'jojobets_db52', '151545Burak.');
?>
